## arpack 3.3.0

=== debian/changelog ===
arpack (3.3.0-1build2) xenial; urgency=medium

  * No-change rebuild for openmpi on s390x.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 06 Feb 2016 19:26:54 +0000

arpack (3.3.0-1build1) xenial; urgency=medium

  * No-change rebuild for openmpi transition.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 01 Feb 2016 11:21:57 +0000

arpack (3.3.0-1) unstable; urgency=medium

  * New upstream release
  * Update of the homepage (moved to github)
  * libparpack links against libarpack (instead of static build)
  * Update the symbol files. No need to change of SONAME:
    - About the parpack change: https://github.com/opencollab/arpack-ng/pull/21
    - Transfer the call to the library:
      https://github.com/opencollab/arpack-ng/pull/19
  * Standards-Version updated to version 3.9.6

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 12 Oct 2015 09:33:05 +0200

arpack (3.1.5-3) unstable; urgency=medium

  * update the symbol list for mips64 & mips64el (Closes: #746277)

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 30 Apr 2014 18:26:52 +0200

=== debian/control ===
Source: arpack
Section: math
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Prud'homme <prudhomm@debian.org>,
 "Adam C. Powell, IV" <hazelsct@debian.org>,
 Sylvestre Ledru <sylvestre@debian.org>
Build-Depends: quilt, debhelper (>= 7.0.50), gfortran,
 libblas-dev, liblapack-dev, mpi-default-dev (>= 0.3), dh-autoreconf
Standards-Version: 3.9.6
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/arpack/trunk/
Vcs-Browser: http://svn.debian.org/viewsvn/debian-science/packages/arpack/
Homepage: https://github.com/opencollab/arpack-ng

Package: libarpack2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: arpack2
Conflicts: arpack2
Breaks: octave3.2
Description: Fortran77 subroutines to solve large scale eigenvalue problems
 ARPACK software is capable of solving large scale symmetric,
 nonsymmetric, and generalized eigenproblems from significant
 application areas. The software is designed to compute a few (k)
 eigenvalues with user specified features such as those of largest
 real part or largest magnitude. Storage requirements are on the order
 of n*k locations. No auxiliary storage is required. A set of Schur
 basis vectors for the desired k-dimensional eigen-space is computed
 which is numerically orthogonal to working precision. Numerically
 accurate eigenvectors are available on request.
 .
 Important Features:
 .
  * Reverse Communication Interface.
  * Single and Double Precision Real Arithmetic Versions for Symmetric,
    Non-symmetric,
  * Standard or Generalized Problems.
  * Single and Double Precision Complex Arithmetic Versions for Standard or
    Generalized Problems.
  * Routines for Banded Matrices - Standard or Generalized Problems.
  * Routines for The Singular Value Decomposition.
  * Example driver routines that may be used as templates to implement
    numerous Shift-Invert strategies for all problem types, data types and
    precision.
 .
 This package contains the shared library.

Package: libarpack2-dev
Section: libdevel
Priority: extra
Architecture: any
Depends:  libarpack2 (= ${binary:Version}), libblas-dev, liblapack-dev,
 ${misc:Depends}
Replaces: arpack2-dev
Conflicts: arpack2-dev
Description: Fortran77 subroutines to solve large scale eigenvalue problems (development)
 ARPACK software is capable of solving large scale symmetric,
 nonsymmetric, and generalized eigenproblems from significant
 application areas. The software is designed to compute a few (k)
 eigenvalues with user specified features such as those of largest
 real part or largest magnitude. Storage requirements are on the order
 of n*k locations. No auxiliary storage is required. A set of Schur
 basis vectors for the desired k-dimensional eigen-space is computed
 which is numerically orthogonal to working precision. Numerically
 accurate eigenvectors are available on request.
 .
 This package contains the static libraries and the documentation for
 development with libarpack (including examples).

Package: libarpack2-dbg
Section: debug
Architecture: any
Priority: extra
Depends:  libarpack2 (= ${binary:Version}), ${misc:Depends}
Description: Fortran77 subroutines to solve large scale eigenvalue problems (debug)
 ARPACK software is capable of solving large scale symmetric,
 nonsymmetric, and generalized eigenproblems from significant
 application areas. The software is designed to compute a few (k)
 eigenvalues with user specified features such as those of largest
 real part or largest magnitude. Storage requirements are on the order
 of n*k locations. No auxiliary storage is required. A set of Schur
 basis vectors for the desired k-dimensional eigen-space is computed
 which is numerically orthogonal to working precision. Numerically
 accurate eigenvectors are available on request.
 .
 This package contains the debugging symbols for libarpack and libparpack.


Package: libparpack2
Section: libs
Architecture: any
Replaces: libarpack2
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Parallel subroutines to solve large scale eigenvalue problems
 ARPACK software is capable of solving large scale symmetric,
 nonsymmetric, and generalized eigenproblems from significant
 application areas. The software is designed to compute a few (k)
 eigenvalues with user specified features such as those of largest
 real part or largest magnitude. Storage requirements are on the order
 of n*k locations. No auxiliary storage is required. A set of Schur
 basis vectors for the desired k-dimensional eigen-space is computed
 which is numerically orthogonal to working precision. Numerically
 accurate eigenvectors are available on request.
 .
 Important Features:
 .
  * Reverse Communication Interface.
  * Single and Double Precision Real Arithmetic Versions for Symmetric,
    Non-symmetric,
  * Standard or Generalized Problems.
  * Single and Double Precision Complex Arithmetic Versions for Standard or
    Generalized Problems.
  * Routines for Banded Matrices - Standard or Generalized Problems.
  * Routines for The Singular Value Decomposition.
  * Example driver routines that may be used as templates to implement
    numerous Shift-Invert strategies for all problem types, data types and
    precision.
 .
 This package provides parpack: the MPI implementation of arpack.
 .
 This package contains the shared library.

Package: libparpack2-dev
Section: libdevel
Priority: extra
Architecture: any
Depends:  libparpack2 (= ${binary:Version}), libblas-dev, liblapack-dev, mpi-default-dev, ${misc:Depends}
Replaces: libarpack2-dev
Description: Parallel subroutines to solve large scale eigenvalue problems (development)
 ARPACK software is capable of solving large scale symmetric,
 nonsymmetric, and generalized eigenproblems from significant
 application areas. The software is designed to compute a few (k)
 eigenvalues with user specified features such as those of largest
 real part or largest magnitude. Storage requirements are on the order
 of n*k locations. No auxiliary storage is required. A set of Schur
 basis vectors for the desired k-dimensional eigen-space is computed
 which is numerically orthogonal to working precision. Numerically
 accurate eigenvectors are available on request.
 .
 This package contains the static libraries and the documentation for
 development with libparpack (including examples).

Package: libparpack2-dbg
Section: debug
Architecture: any
Priority: extra
Depends:  libparpack2 (= ${binary:Version}), ${misc:Depends}
Replaces: libarpack2-dbg
Description: Parallel subroutines to solve large scale eigenvalue problems (debug)
 ARPACK software is capable of solving large scale symmetric,
 nonsymmetric, and generalized eigenproblems from significant
 application areas. The software is designed to compute a few (k)
 eigenvalues with user specified features such as those of largest
 real part or largest magnitude. Storage requirements are on the order
 of n*k locations. No auxiliary storage is required. A set of Schur
 basis vectors for the desired k-dimensional eigen-space is computed
 which is numerically orthogonal to working precision. Numerically
 accurate eigenvectors are available on request.
 .
 This package contains the debugging symbols for libparpack.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh  $@ --with autoreconf

override_dh_auto_configure:
	dh_auto_configure --  --enable-mpi

override_dh_strip:
	dh_strip -Xlibparpack2 --dbg-package=libarpack2-dbg
	dh_strip --dbg-package=libparpack2-dbg

.PHONY: override_dh_strip

=== debian/watch ===
version=3
opts="filenamemangle=s/(?:.*)?v?(\d[\d\.]*)\.tar\.gz/arpack-ng-$1.tar.gz/" \
   https://github.com/opencollab/arpack-ng/tags (?:.*/)?v?(\d[\d\.]*)\.tar\.gz

## arpack 3.4.0

=== debian/changelog ===
arpack (3.4.0-1) unstable; urgency=medium

  * New upstream release
  * mpi_fortran_unweighted_ &  mpi_fortran_weights_empty_ added as new
    symbols
  * Breaks: octave3.2 => removed as octave 3.2 no longer exists in Debian
  * Standards-Version updated to 3.9.8

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 02 Jul 2016 21:54:37 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  Sylvestre Ledru <sylvestre@debian.org>
 Build-Depends: quilt, debhelper (>= 7.0.50), gfortran,
  libblas-dev, liblapack-dev, mpi-default-dev (>= 0.3), dh-autoreconf
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/arpack/trunk/
 Vcs-Browser: http://svn.debian.org/viewsvn/debian-science/packages/arpack/
 Homepage: https://github.com/opencollab/arpack-ng
@@ -18,7 +18,6 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Replaces: arpack2
 Conflicts: arpack2
-Breaks: octave3.2
 Description: Fortran77 subroutines to solve large scale eigenvalue problems
  ARPACK software is capable of solving large scale symmetric,
  nonsymmetric, and generalized eigenproblems from significant

## arpack 3.5.0+real

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.6)

if (NOT DEFINED CMAKE_BUILD_TYPE)
   set (CMAKE_BUILD_TYPE Release CACHE STRING "Build type")
endif ()

project(arpack C Fortran)

# Adopted from https://github.com/feymark/arpack.git

if (POLICY CMP0042)
  # enable MACOSX_RPATH by default
  cmake_policy (SET CMP0042 NEW)
endif ()

option(MPI "Enable parallel support" OFF)
#option(SYSTEM_BLAS "Use system BLAS" ON)
#option(SYSTEM_LAPACK "Use system LAPACK" ON)
option(EXAMPLES "Compile ARPACK examples" OFF)
set(LIBSUFFIX ""
    CACHE STRING "suffix to add to ARPACK libraries names")
set(SYMBOLSUFFIX ""
    CACHE STRING "suffix to add to ARPACK, BLAS and LAPACK function names")
option(INTERFACE64 "use the 64-bit integer interface (ILP64) for ARPACK, BLAS and LAPACK")

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

function(prefixlist list_name prefix)
    set(${list_name}_TMP)
    foreach(l ${${list_name}})
      list(APPEND ${list_name}_TMP ${prefix}${l} )
    endforeach()
    set(${list_name} "${${list_name}_TMP}" PARENT_SCOPE)
endfunction(prefixlist)

function(examples list_name)
    foreach(l ${${list_name}})
        get_filename_component(lwe ${l} NAME_WE)
        add_executable(${lwe} ${arpackexample_DIR}/${l} ${examples_EXTRA_SRCS})
        target_link_libraries(${lwe} arpack ${BLAS_LIBRARIES} ${LAPACK_LIBRARIES})
    endforeach()
endfunction(examples)

function(pexamples list_name)
    foreach(l ${${list_name}})
        get_filename_component(lwe ${l} NAME_WE)
        add_executable(${lwe} ${parpackexample_DIR}/${l} )
        target_link_libraries(${lwe} parpack arpack  ${MPI_Fortran_LIBRARIES})
    endforeach()
endfunction(pexamples)

#if (SYSTEM_BLAS)
    find_package(BLAS REQUIRED)
#endif()
#if (BLAS_LIBRARIES)
#    set(SYSTEM_BLAS ON)
#endif()

if (MPI)
    include(FindMPI)
    find_package(MPI REQUIRED)
    include_directories(${MPI_Fortran_INCLUDE_PATH})
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${MPI_Fortran_COMPILE_FLAG}")
endif()

#if (SYSTEM_LAPACK)
    find_package(LAPACK REQUIRED)
#endif()
#if (BLAS_LIBRARIES)
#    set(SYSTEM_LAPACK ON)
#endif()

if (MPI)
    set(parpackutil_DIR ${arpack_SOURCE_DIR}/PARPACK/UTIL/)
    set(parpacksrc_DIR ${arpack_SOURCE_DIR}/PARPACK/SRC/)
endif()

#if (NOT SYSTEM_BLAS)
#    file(GLOB arpackblas_STAT_SRCS blas/*.f)
#endif()
#if (NOT SYSTEM_LAPACK)
#    file(GLOB arpacklapack_STAT_SRCS lapack/*.f)
#endif()
#file(GLOB arpackutil_STAT_SRCS util/*.f)
file(GLOB arpacksrc_STAT_SRCS SRC/*.f)

set(arpackutil_STAT_SRCS
    UTIL/icnteq.f
    UTIL/icopy.f
    UTIL/iset.f
    UTIL/iswap.f
    UTIL/ivout.f
    UTIL/second_NONE.f
    UTIL/svout.f
    UTIL/smout.f
    UTIL/dvout.f
    UTIL/dmout.f
    UTIL/cvout.f
    UTIL/cmout.f
    UTIL/zvout.f
    UTIL/zmout.f )


if (MPI)
    file(GLOB parpackutil_STAT_SRCS PARPACK/UTIL/MPI/*.f)
    file(GLOB parpacksrc_STAT_SRCS PARPACK/SRC/MPI/*.f)
endif()

#add_library(arpack SHARED
#                   ${arpackblas_STAT_SRCS}
#                   ${arpacklapack_STAT_SRCS}
#                   ${arpackutil_STAT_SRCS}
#                   ${arpacksrc_STAT_SRCS})
add_library(arpack
                   ${arpackutil_STAT_SRCS}
                   ${arpacksrc_STAT_SRCS})

target_link_libraries(arpack ${BLAS_LIBRARIES})
target_link_libraries(arpack ${LAPACK_LIBRARIES})
set_target_properties(arpack PROPERTIES OUTPUT_NAME arpack${LIBSUFFIX})
set_target_properties(arpack PROPERTIES VERSION 2.0.0)
set_target_properties(arpack PROPERTIES SOVERSION 2)

if (MPI)
#    add_library(parpack SHARED
    add_library(parpack
                        ${parpacksrc_STAT_SRCS}
                        ${parpackutil_STAT_SRCS})

    target_link_libraries(parpack ${MPI_Fortran_LIBRARIES})
    target_link_libraries(parpack arpack)
    set_target_properties(parpack PROPERTIES OUTPUT_NAME parpack${LIBSUFFIX})
    set_target_properties(parpack PROPERTIES VERSION 2.0.0)
    set_target_properties(parpack PROPERTIES SOVERSION 2)
endif ()

if (INTERFACE64)
    if ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "GNU")
      set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fdefault-integer-8")
    elseif ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "Intel")
      set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -i8")
    else ()
      message(WARNING "build script does not know how to make your Fortran compiler use 64-bit integers: set it manually via FFLAGS.")
    endif ()

    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DBLASINT=int64_t")
endif ()

if (SYMBOLSUFFIX)
    if ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "GNU")
      set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -cpp -ffixed-line-length-none")
    elseif ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "Intel")
      set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fpp -extend-source")
    else ()
      message(WARNING "build script does not know how to enable your Fortran compiler's preprocessor and support for lines longer than 72 characters: set them manually via FFLAGS.")
    endif ()

    set(SCALARFUNS naitr napps naup2 naupd nconv neigh neupd ngets statn saitr sapps saup2 saupd sconv seigt seupd sgets stats getv0 sortc sortr sesrt stqrb)
    set(COMPLEXFUNS, naitr napps naup2 naupd neigh neupd ngets statn getv0 sortc)

    set(BLASFUNS1 axpy copy gemv geqr2 lacpy lae2 lahqr lanhs larnv lartg lascl laset lasrt scal trevc trmm trsen gbmv gbtrf gbtrs gttrf gttrs pttrf pttrs)
    set(BLASFUNS2 dot ger labad laev2 lamch lanst lanv2 lapy2 larf larfg lasr nrm2 orm2r rot steqr swap)
    set(BLASFUNS3 dotc geru unm2r)
    set(BLASFUNS4 COPY LABAD LAMCH LANHS LANV2 LARFG ROT GEMV)
    set(BLASFUNS5 scnrm2 dznrm2 csscal zdscal)

    foreach (f IN LISTS SCALARFUNS BLASFUNS1 BLASFUNS2)
      set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -Ds${f}=s${f}${SYMBOLSUFFIX} -Dd${f}=d${f}${SYMBOLSUFFIX}")
    endforeach ()

    foreach (f IN LISTS COMPLEXFUNS BLASFUNS1 BLASFUNS3)
      set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -Dc${f}=c${f}${SYMBOLSUFFIX} -Dz${f}=z${f}${SYMBOLSUFFIX}")
    endforeach ()

    foreach (f IN LISTS BLASFUNS4)
      set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -DS${f}=S${f}${SYMBOLSUFFIX} -DD${f}=D${f}${SYMBOLSUFFIX}")
    endforeach ()

    foreach (f IN LISTS BLASFUNS5)
      set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -D${f}=${f}${SYMBOLSUFFIX}")
    endforeach ()
endif ()

set(CFUNS sgemm snaupd sneupd dnaupd dneupd cheev)
foreach (f IN LISTS CFUNS)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D${f}=${f}${SYMBOLSUFFIX}")
  list(APPEND CFUNS_SUFFIXED ${f}${SYMBOLSUFFIX})
endforeach ()

include(FortranCInterface)
FortranCInterface_HEADER(FCMangle.h SYMBOLS ${CFUNS_SUFFIXED})

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DINCLUDE_FCMANGLE")
set(CMAKE_INCLUDE_CURRENT_DIR ON)

############################
# EXAMPLES
############################
if (EXAMPLES)
    ############################
    # EXAMPLES/BAND
    ############################
    set(arpackexample_DIR ${arpack_SOURCE_DIR}/EXAMPLES/BAND/)
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/Examples/band/)

    set(examples_EXTRA_SRCS ${arpackexample_DIR}/cnband.f)
    set(examples_STAT_SRCS
        cnbdr1.f
        cnbdr2.f
        cnbdr3.f
        cnbdr4.f)
    examples(examples_STAT_SRCS)

    set(examples_EXTRA_SRCS ${arpackexample_DIR}/dnband.f)
    set(examples_STAT_SRCS
        dnbdr1.f
        dnbdr2.f
        dnbdr3.f
        dnbdr4.f
        dnbdr5.f
        dnbdr6.f)
    examples(examples_STAT_SRCS)

    set(examples_EXTRA_SRCS ${arpackexample_DIR}/dsband.f)
    set(examples_STAT_SRCS
        dsbdr1.f
        dsbdr2.f
        dsbdr3.f
        dsbdr4.f
        dsbdr5.f
        dsbdr6.f)
    examples(examples_STAT_SRCS)

    set(examples_EXTRA_SRCS ${arpackexample_DIR}/snband.f)
    set(examples_STAT_SRCS
        snbdr1.f
        snbdr2.f
        snbdr3.f
        snbdr4.f
        snbdr5.f
        snbdr6.f)
    examples(examples_STAT_SRCS)

    set(examples_EXTRA_SRCS ${arpackexample_DIR}/ssband.f)
    set(examples_STAT_SRCS
        ssbdr1.f
        ssbdr2.f
        ssbdr3.f
        ssbdr4.f
        ssbdr5.f
        ssbdr6.f)
    examples(examples_STAT_SRCS)

    set(examples_EXTRA_SRCS ${arpackexample_DIR}/znband.f)
    set(examples_STAT_SRCS
        znbdr1.f
        znbdr2.f
        znbdr3.f
        znbdr4.f)
    examples(examples_STAT_SRCS)
    set(examples_EXTRA_SRCS)

    ############################
    # EXAMPLES/COMPLEX
    ############################
    set(arpackexample_DIR ${arpack_SOURCE_DIR}/EXAMPLES/COMPLEX/)
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/Examples/complex/)

    set(examples_STAT_SRCS
        cndrv1.f
        cndrv2.f
        cndrv3.f
        cndrv4.f
        zndrv1.f
        zndrv2.f
        zndrv3.f
        zndrv4.f)
    examples(examples_STAT_SRCS)

    ############################
    # examples/nonsym
    ############################
    set(arpackexample_DIR ${arpack_SOURCE_DIR}/EXAMPLES/NONSYM/)
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/Examples/nonsym/)

    set(examples_STAT_SRCS
        dndrv1.f
        dndrv2.f
        dndrv3.f
        dndrv4.f
        dndrv5.f
        dndrv6.f
        sndrv1.f
        sndrv2.f
        sndrv3.f
        sndrv4.f
        sndrv5.f
        sndrv6.f)
    examples(examples_STAT_SRCS)

    ############################
    # examples/SIMPLE
    ############################
    set(arpackexample_DIR ${arpack_SOURCE_DIR}/EXAMPLES/SIMPLE/)
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/Examples/simple/)

    set(examples_STAT_SRCS
        cnsimp.f
        dnsimp.f
        dssimp.f
        snsimp.f
        sssimp.f
        znsimp.f)

    examples(examples_STAT_SRCS)

    ############################
    # examples/svd
    ############################
    set(arpackexample_DIR ${arpack_SOURCE_DIR}/EXAMPLES/SVD/)
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/Examples/svd/)

    set(examples_STAT_SRCS
        ssvd.f)

    examples(examples_STAT_SRCS)

    ############################
    # examples/sym
    ############################
    set(arpackexample_DIR ${arpack_SOURCE_DIR}/EXAMPLES/SYM/)
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/Examples/sym/)

    set(examples_STAT_SRCS
        dsdrv1.f
        dsdrv2.f
        dsdrv3.f
        dsdrv4.f
        dsdrv5.f
        dsdrv6.f
        ssdrv1.f
        ssdrv2.f
        ssdrv3.f
        ssdrv4.f
        ssdrv5.f
        ssdrv6.f)

    examples(examples_STAT_SRCS)

    ############################
    # parpack/examples
    ############################
    if (MPI)
        set(parpackexample_DIR ${arpack_SOURCE_DIR}/PARPACK/EXAMPLES/MPI/)
        set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/Examples/parpack)

        set(pexamples_STAT_SRCS
            pcndrv1.f
            pdndrv1.f
            pdndrv3.f
            pdsdrv1.f
            psndrv1.f
            psndrv3.f
            pssdrv1.f
            pzndrv1.f)

        pexamples(pexamples_STAT_SRCS)
    endif()
endif()


############################
# CHECK
############################

enable_testing()

set(CMAKE_CTEST_COMMAND ctest -V)

add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/Tests)

add_executable(dnsimp_test EXCLUDE_FROM_ALL TESTS/dnsimp.f TESTS/mmio.f TESTS/debug.h)
set_target_properties( dnsimp_test PROPERTIES OUTPUT_NAME  dnsimp )
target_link_libraries(dnsimp_test arpack ${BLAS_LIBRARIES} ${LAPACK_LIBRARIES})
add_custom_command(TARGET dnsimp_test POST_BUILD
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/TESTS/testA.mtx testA.mtx
)
add_test(dnsimp_test Tests/dnsimp)

add_executable(bug_1315_single EXCLUDE_FROM_ALL TESTS/bug_1315_single.c)
target_link_libraries(bug_1315_single arpack ${BLAS_LIBRARIES} ${LAPACK_LIBRARIES})
add_test(bug_1315_single Tests/bug_1315_single)

add_executable(bug_1315_double EXCLUDE_FROM_ALL TESTS/bug_1315_double.c)
target_link_libraries(bug_1315_double arpack ${BLAS_LIBRARIES} ${LAPACK_LIBRARIES})

=== debian/changelog ===
arpack (3.5.0+real-2) unstable; urgency=medium

  * Team upload.
  * Moved packaging from SVN to Git
  * Standards-Version: 4.1.3

 -- Andreas Tille <tille@debian.org>  Wed, 24 Jan 2018 09:06:55 +0100

arpack (3.5.0+real-1) unstable; urgency=medium

  * Team upload.
  * Really upload 3.5.0 upstream release. (Closes: #875697)
  * Fix debian/watch file (and upgrade to format version 4).
  * Update symbols file for libparpack2.
  * Bump to debhelper compat level 10.
  * Mark shared and development library packages as Multi-Arch: same.
  * Enforce generic BLAS (to avoid tying to ATLAS or OpenBLAS).
  * Ship arpack.pc in libarpack2-dev.
  * Use canonical URLs for Vcs-* fields.
  * Install doc using dh_installdocs (instead of dh_install).
  * Migrate to -dbgsym debug packages.
  * Bump priority of -dev packages to optional, per policy 4.0.1.
  * Add BLAS/LAPACK virtual -dev packages as alternatives in dependency list of
    ARPACK -dev packages (Closes: #757189)
  * Bump Standards-Version to 4.1.0.
  * Remove obsolete README.source.
  * Remove obsolete source lintian override.
  * Remove obsolete Conflicts+Replaces on arpack2{,-dev}.

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 14 Sep 2017 12:16:59 +0200

arpack (3.5.0-1) unstable; urgency=medium

  * Upload to unstable

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 18 Jun 2017 19:24:59 +0200

arpack (3.5.0-1~exp1) experimental; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 16 May 2017 13:37:16 +0200

arpack (3.4.0-2) unstable; urgency=medium

  * Remove MIA maintainers (Closes: #835005)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 21 Aug 2016 16:08:00 +0200

=== debian/control ===
--- 
+++ 
@@ -1,23 +1,24 @@
 Source: arpack
+Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Sylvestre Ledru <sylvestre@debian.org>
 Section: math
 Priority: optional
-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Christophe Prud'homme <prudhomm@debian.org>,
- "Adam C. Powell, IV" <hazelsct@debian.org>,
- Sylvestre Ledru <sylvestre@debian.org>
-Build-Depends: quilt, debhelper (>= 7.0.50), gfortran,
- libblas-dev, liblapack-dev, mpi-default-dev (>= 0.3), dh-autoreconf
-Standards-Version: 3.9.8
-Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/arpack/trunk/
-Vcs-Browser: http://svn.debian.org/viewsvn/debian-science/packages/arpack/
+Build-Depends: debhelper (>= 10),
+               gfortran,
+               libblas-dev,
+               liblapack-dev,
+               mpi-default-dev
+Standards-Version: 4.1.3
+Vcs-Browser: https://salsa.debian.org/science-team/arpack.git
+Vcs-Git: https://salsa.debian.org/science-team/arpack.git
 Homepage: https://github.com/opencollab/arpack-ng
 
 Package: libarpack2
+Architecture: any
+Multi-Arch: same
 Section: libs
-Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Replaces: arpack2
-Conflicts: arpack2
+Depends: ${shlibs:Depends},
+         ${misc:Depends}
 Description: Fortran77 subroutines to solve large scale eigenvalue problems
  ARPACK software is capable of solving large scale symmetric,
  nonsymmetric, and generalized eigenproblems from significant
@@ -46,13 +47,13 @@
  This package contains the shared library.
 
 Package: libarpack2-dev
+Architecture: any
+Multi-Arch: same
 Section: libdevel
-Priority: extra
-Architecture: any
-Depends:  libarpack2 (= ${binary:Version}), libblas-dev, liblapack-dev,
- ${misc:Depends}
-Replaces: arpack2-dev
-Conflicts: arpack2-dev
+Depends: libarpack2 (= ${binary:Version}),
+         libblas-dev | libblas.so,
+         liblapack-dev | liblapack.so,
+         ${misc:Depends}
 Description: Fortran77 subroutines to solve large scale eigenvalue problems (development)
  ARPACK software is capable of solving large scale symmetric,
  nonsymmetric, and generalized eigenproblems from significant
@@ -67,30 +68,13 @@
  This package contains the static libraries and the documentation for
  development with libarpack (including examples).
 
-Package: libarpack2-dbg
-Section: debug
+Package: libparpack2
 Architecture: any
-Priority: extra
-Depends:  libarpack2 (= ${binary:Version}), ${misc:Depends}
-Description: Fortran77 subroutines to solve large scale eigenvalue problems (debug)
- ARPACK software is capable of solving large scale symmetric,
- nonsymmetric, and generalized eigenproblems from significant
- application areas. The software is designed to compute a few (k)
- eigenvalues with user specified features such as those of largest
- real part or largest magnitude. Storage requirements are on the order
- of n*k locations. No auxiliary storage is required. A set of Schur
- basis vectors for the desired k-dimensional eigen-space is computed
- which is numerically orthogonal to working precision. Numerically
- accurate eigenvectors are available on request.
- .
- This package contains the debugging symbols for libarpack and libparpack.
-
-
-Package: libparpack2
+Multi-Arch: same
 Section: libs
-Architecture: any
+Depends: ${shlibs:Depends},
+         ${misc:Depends}
 Replaces: libarpack2
-Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Parallel subroutines to solve large scale eigenvalue problems
  ARPACK software is capable of solving large scale symmetric,
  nonsymmetric, and generalized eigenproblems from significant
@@ -121,10 +105,14 @@
  This package contains the shared library.
 
 Package: libparpack2-dev
+Architecture: any
+Multi-Arch: same
 Section: libdevel
-Priority: extra
-Architecture: any
-Depends:  libparpack2 (= ${binary:Version}), libblas-dev, liblapack-dev, mpi-default-dev, ${misc:Depends}
+Depends: libparpack2 (= ${binary:Version}),
+         libblas-dev | libblas.so,
+         liblapack-dev | liblapack.so,
+         mpi-default-dev,
+         ${misc:Depends}
 Replaces: libarpack2-dev
 Description: Parallel subroutines to solve large scale eigenvalue problems (development)
  ARPACK software is capable of solving large scale symmetric,
@@ -139,22 +127,3 @@
  .
  This package contains the static libraries and the documentation for
  development with libparpack (including examples).
-
-Package: libparpack2-dbg
-Section: debug
-Architecture: any
-Priority: extra
-Depends:  libparpack2 (= ${binary:Version}), ${misc:Depends}
-Replaces: libarpack2-dbg
-Description: Parallel subroutines to solve large scale eigenvalue problems (debug)
- ARPACK software is capable of solving large scale symmetric,
- nonsymmetric, and generalized eigenproblems from significant
- application areas. The software is designed to compute a few (k)
- eigenvalues with user specified features such as those of largest
- real part or largest magnitude. Storage requirements are on the order
- of n*k locations. No auxiliary storage is required. A set of Schur
- basis vectors for the desired k-dimensional eigen-space is computed
- which is numerically orthogonal to working precision. Numerically
- accurate eigenvectors are available on request.
- .
- This package contains the debugging symbols for libparpack.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure:
	# Enforce generic BLAS (to avoid tying to ATLAS or OpenBLAS)
	dh_auto_configure --  --enable-mpi --with-blas=blas

override_dh_strip:
	dh_strip --dbgsym-migration='libarpack2-dbg (<< 3.5.0+real-1~), libparpack2-dbg (<< 3.5.0+real-1~)'

## arpack 3.6.2

=== debian/changelog ===
arpack (3.6.2-1) unstable; urgency=medium

  * New upstream release
    Should fix FTBFS on armel, mips64el, ppc64el
    (Closes: #904091)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 22 Jul 2018 17:41:40 +0200

arpack (3.6.1-1) unstable; urgency=medium

  * New upstream release.
    Hopefully fix a regression on i386 and other archs

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 09 Jun 2018 18:31:25 +0200

arpack (3.6.0-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.1.4
  * Update of the copyright file

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 05 Jun 2018 21:01:11 +0200

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
                libblas-dev,
                liblapack-dev,
                mpi-default-dev
-Standards-Version: 4.1.3
+Standards-Version: 4.1.4
 Vcs-Browser: https://salsa.debian.org/science-team/arpack.git
 Vcs-Git: https://salsa.debian.org/science-team/arpack.git
 Homepage: https://github.com/opencollab/arpack-ng

## arpack 3.6.3

=== debian/changelog ===
arpack (3.6.3-1) unstable; urgency=medium

  * New upstream release
    fix a regression with dnaupd (Closes: #908648)
  * Standards-Version: 4.2.1

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 19 Sep 2018 10:05:11 +0200

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
                libblas-dev,
                liblapack-dev,
                mpi-default-dev
-Standards-Version: 4.1.4
+Standards-Version: 4.2.1
 Vcs-Browser: https://salsa.debian.org/science-team/arpack.git
 Vcs-Git: https://salsa.debian.org/science-team/arpack.git
 Homepage: https://github.com/opencollab/arpack-ng

## arpack 3.7.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.6)

if (NOT DEFINED CMAKE_BUILD_TYPE)
   set (CMAKE_BUILD_TYPE Release CACHE STRING "Build type")
endif ()

project(arpack C Fortran)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)

# Adopted from https://github.com/feymark/arpack.git

if (POLICY CMP0042)
  # enable MACOSX_RPATH by default
  cmake_policy (SET CMP0042 NEW)
endif ()

option(MPI "Enable parallel support" OFF)
option(ICB "Enable support for *[ae]upd_c with ISO_C_BINDING" OFF)
option(ICBEXMM "Enable support for matrix market example based on ICB" OFF)
#option(SYSTEM_BLAS "Use system BLAS" ON)
#option(SYSTEM_LAPACK "Use system LAPACK" ON)
option(EXAMPLES "Compile ARPACK examples" OFF)
set(LIBSUFFIX ""
    CACHE STRING "suffix to add to ARPACK libraries names")
set(SYMBOLSUFFIX ""
    CACHE STRING "suffix to add to ARPACK, BLAS and LAPACK function names")
option(INTERFACE64 "use the 64-bit integer interface (ILP64) for ARPACK, BLAS and LAPACK")

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

if (COVERALLS)
    include(Coveralls)
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -g -O0 -fprofile-arcs -ftest-coverage")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -O0 -fprofile-arcs -ftest-coverage")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -O0 -fprofile-arcs -ftest-coverage")
    # The no space is by design: issue in cmake. See CMP0004.
    set(EXTRA_LDLAGS "${EXTRA_LDLAGS}-lgcov")
endif()

function(prefixlist list_name prefix)
    set(${list_name}_TMP)
    foreach(l ${${list_name}})
      list(APPEND ${list_name}_TMP ${prefix}${l} )
    endforeach()
    set(${list_name} "${${list_name}_TMP}" PARENT_SCOPE)
endfunction(prefixlist)

function(examples list_name)
    foreach(l ${${list_name}})
        get_filename_component(lwe ${l} NAME_WE)
        add_executable(${lwe} ${arpackexample_DIR}/${l} ${examples_EXTRA_SRCS})
        target_link_libraries(${lwe} arpack ${BLAS_LIBRARIES} ${LAPACK_LIBRARIES} ${EXTRA_LDLAGS})
        add_test(NAME "${lwe}_ex" COMMAND ${lwe} WORKING_DIRECTORY ${arpackexample_DIR})
    endforeach()
endfunction(examples)

function(pexamples list_name)
    foreach(l ${${list_name}})
        get_filename_component(lwe ${l} NAME_WE)
        add_executable(${lwe} ${parpackexample_DIR}/${l} )
        target_link_libraries(${lwe} parpack arpack  ${MPI_Fortran_LIBRARIES})
    endforeach()
endfunction(pexamples)

if (ICBEXMM)
    find_package(Eigen3)
    if (NOT Eigen3_FOUND) # If not found, piggy-back pkg-config files.
        message(WARNING "CMake didn't find the Eigen3 package. Try to look for pkg-config file...")
        find_package(PkgConfig 3.2 REQUIRED)
        pkg_check_modules(EIGEN3 REQUIRED eigen3>=3.2)
    endif ()

    # Look for headers.
    find_path(EIGEN3_SPARSE_DIR NAMES Sparse PATHS ${EIGEN3_INCLUDE_DIRS} PATH_SUFFIXES Eigen)
    if (NOT EIGEN3_SPARSE_DIR)
        message(FATAL_ERROR "-- Eigen/Sparse header not found.")
    endif ()
    find_path(EIGEN3_ITERATIVE_SOLVER_DIR NAMES IterativeLinearSolvers PATHS ${EIGEN3_INCLUDE_DIRS} PATH_SUFFIXES Eigen)
    if (NOT EIGEN3_ITERATIVE_SOLVER_DIR)
        message(FATAL_ERROR "-- Eigen/IterativeLinearSolvers header not found.")
    endif ()
    find_path(EIGEN3_SLU_SOLVER_DIR NAMES SparseLU PATHS ${EIGEN3_INCLUDE_DIRS} PATH_SUFFIXES Eigen)
    if (NOT EIGEN3_SLU_SOLVER_DIR)
        message(FATAL_ERROR "-- Eigen/SparseLU header not found.")
    endif ()
    find_path(EIGEN3_SQR_SOLVER_DIR NAMES SparseQR PATHS ${EIGEN3_INCLUDE_DIRS} PATH_SUFFIXES Eigen)
    if (NOT EIGEN3_SQR_SOLVER_DIR)
        message(FATAL_ERROR "-- Eigen/SparseQR header not found.")
    endif ()

    set(ICB "ON")
endif ()

# Enable language(s) before any find_package (in particular before MPI find_package).
if (ICB)
    enable_language(C CXX) # For testing binding with c/c++.

    set(CMAKE_CXX_STANDARD 11) # OK, since cmake-3.1 only.

    file(WRITE ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/CMakeTmp/PROG_ICB.f90
         "
          PROGRAM PROG_ICB
          USE iso_c_binding
          IMPLICIT NONE
          INTEGER(C_INT) :: a
          a = 1
          END PROGRAM PROG_ICB
         ")
    try_compile(COMPILE_ICB ${CMAKE_BINARY_DIR} ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/CMakeTmp/PROG_ICB.f90)
    if(NOT ${COMPILE_ICB})
      message(FATAL_ERROR "-- Fortran compiler does not support iso_c_binding.")
    else()
      message("-- Fortran compiler does support iso_c_binding.")
    endif()
else()
    # ICB saves you from old-fashion-boring-cumbersome-fortran/C crap...

    if ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "GNU")
      set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -cpp -ffixed-line-length-none")
    elseif ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "Intel")
      set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fpp -extend-source")
    else ()
      message(WARNING "build script does not know how to enable your Fortran compiler's preprocessor and support for lines longer than 72 characters: set them manually via FFLAGS.")
    endif ()

    set(SCALARFUNS naitr napps naup2 naupd nconv neigh neupd ngets statn saitr sapps saup2 saupd sconv seigt seupd sgets stats getv0 sortc sortr sesrt stqrb)
    set(COMPLEXFUNS, naitr napps naup2 naupd neigh neupd ngets statn getv0 sortc)

    set(BLASFUNS1 axpy copy gemv geqr2 lacpy lae2 lahqr lanhs larnv lartg lascl laset lasrt scal trevc trmm trsen gbmv gbtrf gbtrs gttrf gttrs pttrf pttrs)
    set(BLASFUNS2 dot ger labad laev2 lamch lanst lanv2 lapy2 larf larfg lasr nrm2 orm2r rot steqr swap)
    set(BLASFUNS3 dotc geru unm2r)
    set(BLASFUNS4 COPY LABAD LAMCH LANHS LANV2 LARFG ROT GEMV)
    set(BLASFUNS5 scnrm2 dznrm2 csscal zdscal)

    if (SYMBOLSUFFIX)
        foreach (f IN LISTS SCALARFUNS BLASFUNS1 BLASFUNS2)
            set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -Ds${f}=s${f}${SYMBOLSUFFIX} -Dd${f}=d${f}${SYMBOLSUFFIX}")
        endforeach ()

        foreach (f IN LISTS COMPLEXFUNS BLASFUNS1 BLASFUNS3)
            set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -Dc${f}=c${f}${SYMBOLSUFFIX} -Dz${f}=z${f}${SYMBOLSUFFIX}")
        endforeach ()

        foreach (f IN LISTS BLASFUNS4)
            set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -DS${f}=S${f}${SYMBOLSUFFIX} -DD${f}=D${f}${SYMBOLSUFFIX}")
        endforeach ()

        foreach (f IN LISTS BLASFUNS5)
            set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -D${f}=${f}${SYMBOLSUFFIX}")
        endforeach ()
    endif ()

    set(CFUNS sgemm snaupd sneupd dnaupd dneupd cheev)
    foreach (f IN LISTS CFUNS)
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D${f}=${f}${SYMBOLSUFFIX}")
        list(APPEND CFUNS_SUFFIXED ${f}${SYMBOLSUFFIX})
    endforeach ()

    include(FortranCInterface)
    FortranCInterface_HEADER(FCMangle.h SYMBOLS ${CFUNS_SUFFIXED})

    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DINCLUDE_FCMANGLE")

    FortranCInterface_VERIFY()
endif ()

#if (SYSTEM_BLAS)
    find_package(BLAS REQUIRED)
#endif()
#if (BLAS_LIBRARIES)
#    set(SYSTEM_BLAS ON)
#endif()

if (MPI)
    include(FindMPI)
    find_package(MPI REQUIRED)
    include_directories(${MPI_Fortran_INCLUDE_PATH})
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${MPI_Fortran_COMPILE_FLAG}")

    if(ICB)
        include_directories(${MPI_C_INCLUDE_PATH})
        include_directories(${MPI_CXX_INCLUDE_PATH})
        check_symbol_exists(MPI_Comm_c2f "${MPI_C_INCLUDE_PATH}/mpi.h" MPI_Comm_c2f_FOUND)
        if(NOT ${MPI_Comm_c2f_FOUND})
          message(FATAL_ERROR "symbol MPI_Comm_c2f does not exist")
        endif()
    endif()
endif()

#if (SYSTEM_LAPACK)
    find_package(LAPACK REQUIRED)
#endif()
#if (BLAS_LIBRARIES)
#    set(SYSTEM_LAPACK ON)
#endif()

if (MPI)
    set(parpackutil_DIR ${arpack_SOURCE_DIR}/PARPACK/UTIL/)
    set(parpacksrc_DIR ${arpack_SOURCE_DIR}/PARPACK/SRC/)
endif()

#if (NOT SYSTEM_BLAS)
#    file(GLOB arpackblas_STAT_SRCS blas/*.f)
#endif()
#if (NOT SYSTEM_LAPACK)
#    file(GLOB arpacklapack_STAT_SRCS lapack/*.f)
#endif()
#file(GLOB arpackutil_STAT_SRCS util/*.f)
file(GLOB arpacksrc_STAT_SRCS dbgini.f staini.f ${arpack_SOURCE_DIR}/SRC/*.f)

set(arpacksrc_ICB "")
set(parpacksrc_ICB "")
if(ICB)
  file(GLOB arpacksrc_ICB SRC/icba*.F90 ICB/debug_icb.F90 ICB/stat_icb.F90)
  file(GLOB parpacksrc_ICB PARPACK/SRC/MPI/icbp*.F90 ICB/debug_icb.F90 ICB/stat_icb.F90)
endif()

set(arpackutil_STAT_SRCS
    ${arpack_SOURCE_DIR}/UTIL/icnteq.f
    ${arpack_SOURCE_DIR}/UTIL/icopy.f
    ${arpack_SOURCE_DIR}/UTIL/iset.f
    ${arpack_SOURCE_DIR}/UTIL/iswap.f
    ${arpack_SOURCE_DIR}/UTIL/ivout.f
    ${arpack_SOURCE_DIR}/UTIL/second_NONE.f
    ${arpack_SOURCE_DIR}/UTIL/svout.f
    ${arpack_SOURCE_DIR}/UTIL/smout.f
    ${arpack_SOURCE_DIR}/UTIL/dvout.f
    ${arpack_SOURCE_DIR}/UTIL/dmout.f
    ${arpack_SOURCE_DIR}/UTIL/cvout.f
    ${arpack_SOURCE_DIR}/UTIL/cmout.f
    ${arpack_SOURCE_DIR}/UTIL/zvout.f
    ${arpack_SOURCE_DIR}/UTIL/zmout.f )


if (MPI)
    file(GLOB parpackutil_STAT_SRCS PARPACK/UTIL/MPI/*.f)
    file(GLOB parpacksrc_STAT_SRCS dbgini.f staini.f PARPACK/SRC/MPI/*.f)
endif()

# use -DBUILD_SHARED_LIBS=ON|OFF to control static/shared
add_library(arpack ${arpackutil_STAT_SRCS} ${arpacksrc_STAT_SRCS} ${arpacksrc_ICB})

if(ICB)
  install(FILES ICB/arpack.h DESTINATION include/arpack)
  install(FILES ICB/arpack.hpp DESTINATION include/arpack)
  if (MPI)
    install(FILES ICB/parpack.h DESTINATION include/arpack)
    install(FILES ICB/parpack.hpp DESTINATION include/arpack)
  endif()
endif()

install(FILES debug.h DESTINATION include/arpack)
if(ICB)
  install(FILES ICB/debug_c.h DESTINATION include/arpack)
  install(FILES ICB/debug_c.hpp DESTINATION include/arpack)
endif()

install(FILES stat.h DESTINATION include/arpack)
if(ICB)
  install(FILES ICB/stat_c.h DESTINATION include/arpack)
  install(FILES ICB/stat_c.hpp DESTINATION include/arpack)
endif()

target_link_libraries(arpack ${BLAS_LIBRARIES})
target_link_libraries(arpack ${LAPACK_LIBRARIES} ${EXTRA_LDLAGS})
set_target_properties(arpack PROPERTIES OUTPUT_NAME arpack${LIBSUFFIX})
set_target_properties(arpack PROPERTIES VERSION 2.1.0)
set_target_properties(arpack PROPERTIES SOVERSION 2)

if (MPI)
    # use -DBUILD_SHARED_LIBS=ON|OFF to control static/shared
    add_library(parpack ${parpacksrc_STAT_SRCS} ${parpackutil_STAT_SRCS} ${parpacksrc_ICB})

    if (ICB)
        target_include_directories(parpack PUBLIC ${MPI_C_INCLUDE_DIRS})
        target_include_directories(parpack PUBLIC ${MPI_CXX_INCLUDE_DIRS})
        target_link_libraries(parpack ${MPI_C_LIBRARIES})
        target_link_libraries(parpack ${MPI_CXX_LIBRARIES})
    endif()
    target_include_directories(parpack PUBLIC ${MPI_Fortran_INCLUDE_DIRS})
    target_link_libraries(parpack ${MPI_Fortran_LIBRARIES})
    target_link_libraries(parpack arpack)
    set_target_properties(parpack PROPERTIES OUTPUT_NAME parpack${LIBSUFFIX})
    set_target_properties(parpack PROPERTIES VERSION 2.1.0)
    set_target_properties(parpack PROPERTIES SOVERSION 2)
endif ()

if (INTERFACE64)
    set(INTERFACE64 1)
    if ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "GNU")
      set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fdefault-integer-8")
    elseif ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "Intel")
      set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -i8")
    else ()
      message(WARNING "build script does not know how to make your Fortran compiler use 64-bit integers: set it manually via FFLAGS.")
    endif ()
else ()
    set(INTERFACE64 0)
endif ()

message("-- Generating arpackdef.h")
configure_file(arpackdef.h.in "${PROJECT_BINARY_DIR}/arpackdef.h" @ONLY)
include_directories("${PROJECT_BINARY_DIR}") # Find arpackdef.h
install(FILES "${PROJECT_BINARY_DIR}/arpackdef.h" DESTINATION include/arpack)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

############################
# EXAMPLES
############################
if (EXAMPLES)
    ############################
    # EXAMPLES/BAND
    ############################
    set(arpackexample_DIR ${arpack_SOURCE_DIR}/EXAMPLES/BAND/)

=== debian/changelog ===
arpack (3.7.0-3) unstable; urgency=medium

  * Enable C/C++ bindings

 -- Julien Schueller <schueller@phimeca.com>  Thu, 31 Oct 2019 17:29:41 +0100

arpack (3.7.0-2) unstable; urgency=medium

  * Team upload.
  * Fix FTBFS on single core builders
    - New patch 0001-Run-MPI-tests-on-a-single-cpu.patch
    Thanks to Santiago Vila (Closes: #926935)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 25 Apr 2019 00:34:46 +0200

arpack (3.7.0-1) unstable; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 12 Jan 2019 16:29:41 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,8 @@
                gfortran,
                libblas-dev,
                liblapack-dev,
-               mpi-default-dev
+               mpi-default-dev,
+               libeigen3-dev
 Standards-Version: 4.2.1
 Vcs-Browser: https://salsa.debian.org/science-team/arpack.git
 Vcs-Git: https://salsa.debian.org/science-team/arpack.git

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,11 @@
 
 override_dh_auto_configure:
 	# Enforce generic BLAS (to avoid tying to ATLAS or OpenBLAS)
-	dh_auto_configure --  --enable-mpi --with-blas=blas
+	dh_auto_configure --  --enable-mpi --with-blas=blas --enable-icb
+
+override_dh_auto_test:
+# Disable fakeroot because of https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=839387
+	env -u LD_PRELOAD make check
 
 override_dh_strip:
 	dh_strip --dbgsym-migration='libarpack2-dbg (<< 3.5.0+real-1~), libparpack2-dbg (<< 3.5.0+real-1~)'
